#include "pin.h"
#include <iostream.h>
#include "iintelhex.h"
#include <time.h>
#include <math.h>
#include <stdio.h>
#include <iomanip.h>

/// se crean objetos globales ////
Pinout clk(0);
Pinout din(1);
Pinout pcadd(2);
Pinout sel(3);
Pinout noe(4);
Pinout pgm(5);
Pinout vcc(6);
Pinout g6(8);
Pinout vpp(10);
Pinin in(6);

void delay( unsigned int time )
{
	clock_t wait=(clock_t)time;
	clock_t goal;
	goal = wait + clock();
	while( goal > clock() );
}
	
void enter(unsigned int *out){ 
	unsigned int sal1=*out;
	clk.resetall(&sal1);
	delay(1);
	vcc.setval(1,&sal1);
	delay(1);
	noe.setval(1,&sal1);din.setval(1,&sal1);
	delay(1);
	g6.setval(1,&sal1);
	delay(1);
	vpp.setval(1,&sal1);
	delay(1);
	din.setval(0,&sal1);noe.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	for(int j=0;j<10;j++){
		clk.setval(0,&sal1);
		delay(1);
		clk.setval(1,&sal1);
		delay(1);
		}
	clk.setval(0,&sal1);
	delay(1);
	*out=sal1;
	}

void exit(unsigned int *out){
	unsigned int sal1=*out;
	noe.setval(1,&sal1);din.setval(1,&sal1);
	delay(1);
	vpp.setval(0,&sal1);
	delay(1);
	g6.setval(0,&sal1);
	delay(1);
	vcc.setval(0,&sal1);
	*out=sal1;
	}

////////rutina para leer el registro de configuracin////////

int readecon(unsigned int *out){
	unsigned int sal1=*out;
	unsigned int dir=0x20;
	int econ=0;
	vcc.setval(1,&sal1);
	delay(1);
	noe.setval(0,&sal1);din.setval(0,&sal1);
	sel.setval(1,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	for(int j=0;j<8;j++){
		pcadd.setval(0x0001&(dir>>j),&sal1);
		delay(1);
		clk.setval(0,&sal1);
		delay(1);
		clk.setval(1,&sal1);
		delay(1);
		}
	delay(1);
	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);

	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);

	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	for(j=0;j<8;j++){

		econ=(int)pow(2,j)*in.getval()+econ;
		delay(1);
		clk.setval(0,&sal1);
		delay(1);
		clk.setval(1,&sal1);
		}

	delay(1);
	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	clk.setval(0,&sal1);
	
return(econ);

}

////////rutina para programar registro de configuracin////////

void pgmecon(unsigned int dato,unsigned int *out){
	unsigned int sal1=*out;
	unsigned int dir=0x20;
	dato=dato&0x00ff;
	vcc.setval(3,&sal1);
	delay(1);
	noe.setval(0,&sal1);din.setval(0,&sal1);
	delay(1);
	sel.setval(1,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	for(int j=0;j<8;j++){
		pcadd.setval(0x0001&(dir>>j),&sal1);din.setval(0x0001&(dato>>j),&sal1);
		delay(1);
		clk.setval(0,&sal1);
		delay(1);
		clk.setval(1,&sal1);
		delay(1);
		}
	delay(1);
	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	clk.setval(0,&sal1);
	delay(1);
	int ch=0,check;
	do{	pgm.setval(1,&sal1);
		delay(1);
		pgm.setval(0,&sal1);
		delay(1);
		check=in.getval();
		ch++;
		if(check==1){
			pgm.setval(1,&sal1);
			delay(1);
			pgm.setval(0,&sal1);
			delay(1);
			cout<<"econ ok\n";
			}
		if(ch==6)cout<<"econ fallado\n";
		}
	while((check==0)&&(ch<6));
	*out=sal1;
	}

//////////////////////////////////////////////////
//////////           MAIN          ///////////////
//////////////////////////////////////////////////

main(void){

unsigned int sal;
int nb,econ,cur=0;
char *nf;
int c;
nf=new char[20];
clk.resetall(&sal);
cout<<"Ahora puede insertar el chip."<<endl;
cout<<"Ingrese el nombre del archivo que desea grabar en el chip (max 20 caracteres)"<<endl;
cin>>nf;

iintelhex ent(nf);

if(!ent.is_open()){
	cout<<"no se puede abrir el archivo"<<endl;

	return 1;
	}

nb=ent.getnb();

cout<<endl<<"Este archivo consta de "<<nb<<" bytes de programa"<<endl;
cout<<"Ingrese el byte de configuracion del registro econ (en decimal)"<<endl;
cin>>econ;

cout<<endl<<"grabando byte econ...."<<endl;

enter(&sal);
pgmecon(econ,&sal);
exit(&sal);

enter(&sal);
unsigned int recon=readecon(&sal);
exit(&sal);

cout<<endl<<"econ en chips="<<recon<<endl;
if ((recon>>5)&1)cout<<endl<<"Chip protegido."<<endl;

int ch,check,bit,pc,ok=0;
cout<<endl<<"grabando programa..."<<endl;

/*********** rutina de programacin  *************/

enter(&sal);
vcc.setval(3,&sal);
delay(1);
noe.setval(0,&sal);din.setval(0,&sal);
delay(1);
sel.setval(0,&sal);
delay(1);
for(pc=0;pc<nb;pc++){
	clk.setval(1,&sal);
	delay(1);
	ent.getdec(c);
	cout<<endl;
	for (bit=0;bit<8;bit++){
		din.setval(0x0001&(c>>bit),&sal);
		delay(1);
		clk.setval(0,&sal);
		delay(1);
		clk.setval(1,&sal);
		delay(1);
		}
	delay(1);
	clk.setval(0,&sal);
	delay(1);
	clk.setval(1,&sal);
	delay(1);
	clk.setval(0,&sal);
	delay(1);
	ch=0;
	do{	pgm.setval(1,&sal);
		delay(1);
		pgm.setval(0,&sal);
		delay(1);
		check=in.getval();
		ch++;
		if(check==1){
			pgm.setval(1,&sal);
			delay(1);
			pgm.setval(0,&sal);
			delay(1);
			cout<<setw(4)<<pc<<":"<<setw(2)<<hex<<c<<" ok ";
			}
		if(ch==6){ok++;cout<<setw(4)<<pc<<":"<<setw(2)<<hex<<c<<" fallado ";}
		}
	while((check==0)&&(ch<6));
	}
exit(&sal);

if(ok==0){
	cout<<endl<<endl<<"Programacion exitosa.";
	}
else {
	cout<<endl<<endl<<"Programacion fallida.";
	}

char q='n';
cout<<endl<<"Desea terminar (s/n)?"<<endl;
while(q!='s')cin>>q;

return 0;

}

