#ifndef PIN
#define PIN
#include <conio.h>


/*** Clase Pinout  ***/

class Pinout {
short int n0;
unsigned int pdato;
unsigned int pcontrol;

public:
Pinout(short int n, unsigned short int port);
void setval(unsigned int v, unsigned int *out);
void resetall(unsigned int *out);

};

/*** Clase Pinin  ***/

class Pinin {
short int n0;
unsigned int pstatus;

public:
Pinin(short int n, unsigned short int port);
unsigned int getval(void);
};

/*** Metodos para la clase Pinout  **/

Pinout::Pinout(short int n, unsigned short int port=2){
	n0=n;

	if(port==1){
		pdato=0x3bc;
		pcontrol=0xbe;
		}

	if (port==2){
		pdato=0x378;
		pcontrol=0x37a;
		}

	if(port==3){
		pdato=0x278;
		pcontrol=0x27a;
		}
	}

void Pinout::setval(unsigned int v, unsigned int *out){
	
	if(n0<6){ 
		*out=((v<<n0)|(~(1<<n0)&*out));
		_outpw(pdato,0x00ff&*out);
		}
	if(n0==6){
		*out=((v<<n0)|(0xff3f&*out));
		_outpw(pdato,0x00ff&*out);
		}
	if(n0>7){
		*out=((v<<n0)|(~(1<<n0)&*out));
		_outpw(pcontrol,*out>>8);
		}
	}

void Pinout::resetall(unsigned int *out){
	*out=0x0000;
	_outpw(pdato,0x00);
	_outpw(pcontrol,0x00);
	}

/*** Metodos para la clase Pinin ***/
Pinin::Pinin(short int n, unsigned short int port=2){
	n0=n;

	if(port==1){
		pstatus=0x3bd;
		}

	if (port==2){
		pstatus=0x379;
		}

	if(port==3){
		pstatus=0x279;
		}
	}

unsigned int Pinin::getval(void){
	return((_inpw(pstatus)>>n0)&0x1);
	}

#endif
