#include "pin.h"
#include <iostream.h>
#include <time.h>
#include <math.h>
#include <stdio.h>
#include <iomanip.h>

/// se crean objetos globales ////
Pinout clk(0);
Pinout din(1);
Pinout pcadd(2);
Pinout sel(3);
Pinout noe(4);
Pinout pgm(5);
Pinout vcc(6);
Pinout g6(8);
Pinout vpp(10);
Pinin in(6);

void delay( unsigned int time )
{
	clock_t wait=(clock_t)time;
	clock_t goal;
	goal = wait + clock();
	while( goal > clock() );
}
	
void enter(unsigned int *out){ 
	unsigned int sal1=*out;
	clk.resetall(&sal1);
	delay(1);
	vcc.setval(1,&sal1);
	delay(1);
	noe.setval(1,&sal1);din.setval(1,&sal1);
	delay(1);
	g6.setval(1,&sal1);
	delay(1);
	vpp.setval(1,&sal1);
	delay(1);
	din.setval(0,&sal1);noe.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	for(int j=0;j<10;j++){
		clk.setval(0,&sal1);
		delay(1);
		clk.setval(1,&sal1);
		delay(1);
		}
	clk.setval(0,&sal1);
	delay(1);
	*out=sal1;
	}

void exit(unsigned int *out){
	unsigned int sal1=*out;
	noe.setval(1,&sal1);din.setval(1,&sal1);
	delay(1);
	vpp.setval(0,&sal1);
	delay(1);
	g6.setval(0,&sal1);
	delay(1);
	vcc.setval(0,&sal1);
	*out=sal1;
	}

int readecon(unsigned int *out){
	unsigned int sal1=*out;
	unsigned int dir=0x20;
	int econ=0;
	vcc.setval(1,&sal1);
	delay(1);
	noe.setval(0,&sal1);din.setval(0,&sal1);
	sel.setval(1,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	for(int j=0;j<8;j++){
		pcadd.setval(0x0001&(dir>>j),&sal1);
		delay(1);
		clk.setval(0,&sal1);
		delay(1);
		clk.setval(1,&sal1);
		delay(1);
		}
	delay(1);
	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);

	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);

	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	for(j=0;j<8;j++){

		econ=(int)pow(2,j)*in.getval()+econ;
		delay(1);
		clk.setval(0,&sal1);
		delay(1);
		clk.setval(1,&sal1);
		}

	delay(1);
	clk.setval(0,&sal1);
	delay(1);
	clk.setval(1,&sal1);
	delay(1);
	clk.setval(0,&sal1);
	
return(econ);

}



void main(int argc, char *argv[]){

unsigned int sal;
int nb,cur=0;
clk.resetall(&sal);
cout<<"Ahora puede insertar el chip."<<endl;
cout<<"Ingrese el numero de bytes que desea leer "<<endl;
cin>>nb;
cout<<endl<<"Leyendo registro econ..."<<endl;

enter(&sal);
cout<<endl<<"el valor de econ es:"<<hex<<readecon(&sal)<<endl;
exit(&sal);

cout<<endl<<"Leyendo memoria de programa..."<<endl<<endl;

enter(&sal);

///rutina de lectura///

vcc.setval(1,&sal);
delay(1);
noe.setval(0,&sal);din.setval(0,&sal);
delay(1);
sel.setval(0,&sal);
delay(1);
clk.setval(1,&sal);
for(int pulso=0;pulso<10;pulso++){
	delay(1);
	clk.setval(0,&sal);
	delay(1);
	clk.setval(1,&sal);
	}
delay(1);
clk.setval(0,&sal);
delay(1);
for(int pc=0;pc<nb;pc++){
	clk.setval(1,&sal);
	delay(1);
	clk.setval(0,&sal);
	delay(1);
	clk.setval(1,&sal);
	delay(1);
	int data=0;
	for(int bit=0;bit<8;bit++){
		data=(int)pow(2,bit)*in.getval()+data;
		clk.setval(0,&sal);
		delay(1);
		clk.setval(1,&sal);
		delay(1);
		}
	cur++;
	cout<<setw(3)<<hex<<data;
	if(cur>15){
		cur=0;
		cout<<endl;
		}
    clk.setval(0,&sal);
    delay(1);
    }

exit(&sal);

cout<<'\n'<<"listo"<<endl;

char q='n';
cout<<"Desea terminar (s/n)"<<endl;
while(q!='s')cin>>q;

}

